package sk.stuba.fei.uim.oop.spring.mvcupdate;

import lombok.Data;
import lombok.NoArgsConstructor;

import java.time.LocalDate;
import java.time.LocalDateTime;

@Data
@NoArgsConstructor
public class ItemResource {

    private long id;
    private boolean checkbox;
    private LocalDate date;
    private LocalDateTime dateTime;
    private long number;
    private String text;

    public ItemResource(Item item) {
        this.id = item.getId();
        this.checkbox = item.isCheckbox();
        this.date = item.getDate();
        this.dateTime = item.getDateTime();
        this.number = item.getNumber();
        this.text = item.getText();
    }

    Item toItem(long id) {
        return new Item(
                id,
                checkbox,
                date,
                dateTime,
                number,
                text
        );
    }
}
